package com.company.jaxws.handler.cardservice.client;

import java.net.URL;
import java.util.Map;

import javax.xml.namespace.QName;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.handler.MessageContext;

import com.company.jaxws.handler.cardservice.creditcard.Address;
import com.company.jaxws.handler.cardservice.creditcard.AuthorizationRequest;
import com.company.jaxws.handler.cardservice.creditcard.AuthorizationStatus;
import com.company.jaxws.handler.cardservice.creditcard.CardUser;
import com.company.jaxws.handler.cardservice.creditcard.CreditCard;
import com.company.jaxws.handler.cardservice.service.CardService;
import com.company.jaxws.handler.cardservice.service.CardServicePortType;

public class CardServiceClient {
	public static void main(String[] args) {
		try {		    
            QName serviceName = new QName("http://cardservice.handler.jaxws.company.com/service", "CardService");
    	    URL wsdlLoc = new URL("http://localhost:8484/creditcard/CardService?wsdl");
	        CardService service = new CardService(wsdlLoc, serviceName);
			CardServicePortType port = service.getCardServicePort();
			
			//CardServicePortType port = new CardService().getCardServicePort();			
	
			Map<String, Object> requestContext = ((BindingProvider)port).getRequestContext();
			//requestContext.put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY,"http://localhost:8484/creditcard/CardService");
			requestContext.put("authn_userid", "yyang");
			requestContext.put("authn_password", "mypassword");
			AuthorizationRequest request = new AuthorizationRequest();
			
			CardUser user = new CardUser();
			CreditCard card = new CreditCard();
			Address ad = new Address();			
			
			user.setFirstName("Young");
			user.setLastName("Yang");
			
			ad.setAddressLine1("1122 Test Rd., Apt #112");
			ad.setAddressLine2(null);
			ad.setCity("New York");
			ad.setState("NY");
			ad.setZip("10041");
			
			
			card.setBillingAddress(ad);
			card.setCardNumber("123456789");
			card.setCcvNumber("098");			
			
			request.setCardUser(user);
			request.setCreditCard(card);
			
			AuthorizationStatus status = new AuthorizationStatus();

			status = port.authorizePayment(request);
						
			Map<String, Object> responseContext = ((BindingProvider)port).getResponseContext();
			Long elapsedTime = (Long) responseContext.get("ELAPSED_TIME");
			
			Integer responseCode = (Integer) responseContext.get(MessageContext.HTTP_RESPONSE_CODE);
			System.out.println("------------------------------------");
			System.out.println("******The Credit Card Authrization Result******");
			System.out.println(" ");
			System.out.println("HTTP Response Code: " + responseCode);
			System.out.println("Authorized ?: " + status.isAuthorized());
			System.out.println("Authorization Token: " + status.getAuthorizationToken());
			System.out.println("Authz Error Code: " + status.getErrorCode());
			System.out.println(" ");
			if (elapsedTime != null)System.out.println("Elapsed Time as Measured in ClientPerformanceMonitorLogicalHandler is : " + elapsedTime.longValue() + "ms");
			System.out.println("------------------------------------");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}	
}
