package com.company.jaxws.handler.cardservice.client;

import java.util.ArrayList;
import java.util.List;

import javax.xml.namespace.QName;
import javax.xml.ws.handler.Handler;
import javax.xml.ws.handler.HandlerResolver;
import javax.xml.ws.handler.PortInfo;

import com.company.jaxws.handler.cardservice.common.ClientAuthenticationSOAPHandler;
import com.company.jaxws.handler.cardservice.common.ClientPerformanceMonitorLogicalHandler;
import com.company.jaxws.handler.cardservice.common.EnvelopeLoggingSOAPHandler;
import com.company.jaxws.handler.cardservice.common.JAXPPayloadLoggingLogicalHandler;

public class CardServiceHandlerResolver implements HandlerResolver {

	public List<Handler> getHandlerChain(PortInfo portInfo) {
		List<Handler> handlerChain = new ArrayList<Handler>();

		ClientAuthenticationSOAPHandler authn = new ClientAuthenticationSOAPHandler();
		EnvelopeLoggingSOAPHandler logging = new EnvelopeLoggingSOAPHandler();
		ClientPerformanceMonitorLogicalHandler perf = new ClientPerformanceMonitorLogicalHandler();
		JAXPPayloadLoggingLogicalHandler payload = new JAXPPayloadLoggingLogicalHandler();

		QName serviceName = portInfo.getServiceName();
		QName portName = portInfo.getPortName();
		String bindingID = portInfo.getBindingID();

		if (serviceName.getNamespaceURI().equals(
				"http://cardservice.handler.jaxws.company.com/service")
				&& serviceName.getLocalPart().equalsIgnoreCase("CardService")) {
			handlerChain.add(authn);
			handlerChain.add(logging);
		}

		if (portName.getNamespaceURI().equals(
				"http://cardservice.handler.jaxws.company.com/service")
				&& portName.getLocalPart().equalsIgnoreCase("CardServicePort")) {
			handlerChain.add(perf);
		}

		if (bindingID.equals("http://schemas.xmlsoap.org/wsdl/soap/http")) {
			handlerChain.add(payload);
		}

		if (bindingID
				.equals("http://java.sun.com/xml/ns/jaxws/2003/05/soap/bindings/HTTP/")) {
			handlerChain.add(payload);
		}

		return handlerChain;
	}
}
