package com.company.jaxws.handler.cardservice.client;

import java.io.IOException;
import java.io.OutputStream;
import java.io.StringReader;
import java.io.ByteArrayOutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.FileInputStream;


import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.MessageFactory;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;

public class CreditCardUtil {

	/**
	 * Returns contents for a file in string format
	 * 
	 * @throws IOException
	 */
	public static String readStringFromFile(String filename)
			throws IOException {
		StringBuffer sb = new StringBuffer();
		BufferedReader br = new BufferedReader(new InputStreamReader(
				new FileInputStream(filename)));
		String input = br.readLine();
		while (input != null) {
			sb.append(input);
			input = br.readLine();
		}
		br.close();
		return sb.toString();
	}

	public static Source xmlStringToSource(String xml) {
		Source src = null;

		StringReader sr = new StringReader(xml);
		src = (Source) new StreamSource(sr);

		return src;
	}

	public static String sourceToXMLString(Source result)
			throws TransformerException {
		String xmlResult = null;

		TransformerFactory factory = TransformerFactory.newInstance();
		Transformer transformer = factory.newTransformer();
		transformer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
		transformer.setOutputProperty(OutputKeys.METHOD, "xml");
		OutputStream out = new ByteArrayOutputStream();
		StreamResult streamResult = new StreamResult();
		streamResult.setOutputStream(out);
		transformer.transform(result, streamResult);
		xmlResult = streamResult.getOutputStream().toString();

		return xmlResult;
	}

	public static SOAPMessage xmlStringToSOAPMessage(String msgString)
			throws SOAPException {
		SOAPMessage message = null;

		MessageFactory factory = MessageFactory.newInstance();
		message = factory.createMessage();
		message.getSOAPPart().setContent(
				(Source) new StreamSource(new StringReader(msgString)));
		message.saveChanges();

		return message;
	}

	public static String soapMessageToXMLString(SOAPMessage msg)
			throws SOAPException, IOException {
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		msg.writeTo(out);
		String xmlString = out.toString();
		out.close();
		return xmlString;

	}
}
