package com.company.jaxws.handler.cardservice.common;

import java.io.PrintStream;
import javax.xml.transform.Source;
import javax.xml.ws.LogicalMessage;
import javax.xml.ws.handler.LogicalHandler;
import javax.xml.ws.handler.LogicalMessageContext;
import javax.xml.ws.handler.MessageContext;

/**
 * The payload using Source class from JAXP.
 */
public class JAXPPayloadLoggingLogicalHandler extends
		BaseHandler<LogicalMessageContext> implements
		LogicalHandler<LogicalMessageContext> {
	private static PrintStream out = System.out;

	private static final String HANDLER_NAME = "JAXPPayloadLoggingLogicalHandler";

	public JAXPPayloadLoggingLogicalHandler() {
		super();
		super.setHandlerName(HANDLER_NAME);
	}

	public boolean handleMessage(LogicalMessageContext smc) {
		out.println("------------------------------------");
		out.println("In LogicalHandler " + HandlerName + ":handleMessage()");

		logToSystemOut(smc);

		out.println("Exiting LogicalHandler " + HandlerName
				+ ":handleMessage()");
		out.println("------------------------------------");

		return true;
	}

	private void logToSystemOut(LogicalMessageContext smc) {
		Boolean outboundProperty = (Boolean) smc
				.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);

		if (outboundProperty.booleanValue()) {
			out.println("\ndirection = outbound ");
		} else {
			out.println("\ndirection = inbound ");
		}

		LogicalMessage message = smc.getMessage();

		try {
			Source src = message.getPayload();
			out.println(HandlerUtil.getXMLFromSource(src));
		} catch (Exception e) {
			out.println("Exception in " + HandlerName + ":" + e);
		}
	}

}
